<template>
  <div id="app">
    <block color="#ef5350">
      <text-field
        placeholder="Label"
        :value="label"
        @input="label = $event.target.value"
        :size="18"
        editable
      />
    </block>
    <block :height="285" color="#ffca28">
      <div class="listview">
        <row v-for="(item, idx) in items" :key="idx">
          <radio slot="icon-cell" :color="item.length > 0 ? '#212121' : '#fafafa'" />
          <text-field
            slot="left-cell"
            placeholder="Item"
            :value="item"
            @input="addItem(idx)($event)"
            editable
          />
        </row>
        <row>
          <text-field
            slot="right-cell"
            type="number"
            placeholder="Price"
            :value="price"
            @input="price = $event.target.value"
            editable
          />
        </row>
      </div>
    </block>
    <block color="#ffa726">
      <hyper-link v-if="isValid" @click="addNewPizza" :size="18">Save</hyper-link>
      <hyper-link @click="() => $router.history.push('/')" :size="18">Back</hyper-link>
    </block>
  </div>
</template>

<script>
import { mapActions } from 'vuex';
import { Block, Row, HyperLink, TextField, Radio } from '../layers';
import { capitalize } from '@/utils';

export default {
  components: {
    Block,
    Row,
    HyperLink,
    TextField,
    Radio
  },
  data() {
    return {
      label: '',
      items: [''],
      price: 0
    };
  },
  computed: {
    isValid() {
      const allItems = this.items.filter(item => item.length > 0);

      return this.label.length > 0 && allItems.length > 0 && this.price.length > 0;
    }
  },
  methods: {
    ...mapActions(['addPizza']),
    addItem(index) {
      return event => {
        const value = event.target.value;

        const newItems = this.items.map((item, idx) => (idx === index ? value : item));

        if (value.length > 0) {
          if (this.items[index + 1] === undefined) {
            this.items = [...newItems, ''];
          } else {
            this.items = newItems;
          }
        } else {
          this.items = newItems.filter((_, idx) => idx !== index + 1);
        }
      };
    },
    addNewPizza() {
      if (this.isValid) {
        this.addPizza({
          label: capitalize(this.label),
          items: this.items.filter(item => item.length > 0),
          price: parseFloat(this.price)
        });

        this.$router.history.push('/');
      }
    }
  }
};
</script>

<style lang="scss">
#app {
  display: flex;
  flex-direction: column;
  justify-content: center;
  height: 90vh;

  > div {
    margin: 10px auto;
    width: 310px;
  }
}

.listview {
  display: flex;
  flex-direction: column;
  height: calc(100% - 10px);
  overflow-y: scroll;
  padding-bottom: 5px;
  margin: 0 auto;
  z-index: 2;
}
</style>
